
#ifndef MASH_TRANSMOGRIFY
#define MASH_TRANSMOGRIFY


#include <tclcl.h>
#include "archive/archive-file.h"
#include "archive/rtp-archive.h"
#include "net/pktbuf.h"


class EditRTP : public TclObject {
public:
	EditRTP();
	~EditRTP() {}
	int datafile(int argc, const char * const *argv);
	int indexfile(int argc, const char * const *argv);
	int outdata(int argc, const char * const *argv);
	int outindex(int argc, const char * const *argv);
	int go(int argc, const char * const *argv);
	int find_cut(int argc, const char * const *argv);
protected:
	DataFile *DataFile_ () { return dataFile_; }
	IndexFile *IndexFile_() { return indexFile_;}
	DataFile *OutDataFile_() { return outdataFile_; }
	IndexFile *OutIndexFile_() { return outindexFile_;}

	void DataFile_ (DataFile  *file) { dataFile_ = file; }
	void IndexFile_(IndexFile *file) { indexFile_= file; }
	void OutDataFile_ (DataFile  *file) { outdataFile_ = file; }
	void OutIndexFile_(IndexFile *file) { outindexFile_= file; }

	int diff(timeval sent, timeval recv, int margin);

	DataFile* dataFile_;
	IndexFile* indexFile_;
	DataFile* outdataFile_;
	IndexFile* outindexFile_;

	u_int32_t scale_;
	u_int32_t ref_rtp_;
	u_int32_t ref_tv_sec_;
	u_int32_t ref_tv_usec_;
	double ref_rec_;
	
	int adjust_;
	BufferPool* bufpool_;

	
	int times[100];
};
	
		


#endif
