/*      $Id: appmgr-srm.h,v 1.11 1997/11/25 08:02:11 tecklee Exp $    */
#ifndef appmgr_srm_h
#define appmgr_srm_h

#include "pktbuf.h"
#include <sys/types.h>
#ifndef WIN32
#   include <sys/uio.h>
#   include <unistd.h>
#endif
#include "session-srm.h"
#include "source-srm.h"
#include "srm.h"

class SRM_Session;
class SRM_Packet;
class SRM_PacketHandler;

class SRM_AppMgr : public TclObject {
public:
    SRM_AppMgr(SRM_Packet *pkt);
    virtual ~SRM_AppMgr() { } ; 
    virtual int next_ADU(u_char *db, int len, srm_src &id, int &pkt_type,
			 int &next);
    virtual SRM_PacketHandler *new_source(const srm_src &sid, int islocal);
    // "islocal" is non-zero for a local source obj

    // Application fills in the "last sequence number" that it has 
    // sent out so far. 
    virtual int periodic_update(u_char *buf);

    virtual void handle_request(const srm_src &/*sid*/, u_char *pb, int len) {
	handle_request(pb, len);
    }
    virtual void handle_reply(const srm_src &/*sid*/, u_char *pb, int len) {
	handle_reply(pb, len);
    }
    virtual void handle_SA(const srm_src &/*sid*/, u_char *pb, int len) {
	handle_SA(pb, len);
    }

    /*
     * we really ought to be using only the above definitions
     * the ones below are provided just for compatibility with the existing
     * version of mb
     */
    virtual void handle_request(u_char *pb, int len);
    virtual void handle_reply(u_char *pb, int len);
    virtual void handle_SA(u_char *pb, int len);

    SRM_Session* session() const { return ss_; }
	
    int command(int argc, const char*const* argv);

protected:
    int app_seqno_;
    u_char *t_dat_;
    SRM_Session *ss_;
    SRM_Packet *sp_;
};



class SRM_Packet : public TclObject{
public:
    SRM_Packet(const char *);
    ~SRM_Packet() { } ;
    int command(int argc, const char*const* argv);

    pktbuf *data(){  
	return t_dat_;
    };

    int length() {  
	return t_dat_->len;
    };

protected:
    pktbuf *t_dat_;
};


#endif
