#
# Copyright (c) @ Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/common/smash-compat.tcl,v 1.2 1997/10/27 21:31:55 elan Exp $
#
proc option args {
	global _db
	if { [lindex $args 0] == "add" } {
		set o [split [lindex $args 1] .]
		set cls [lindex $o 0]
		set resource [lindex $o 1]
		set value [lindex $args 2]
		set pri [lindex $args 3]
		if { $pri == "" } {
			set pri 80
		}
		if [info exists _db($cls,$resource,pri)] {
			set oldpri $_db($cls,$resource,pri)
		} else {
			set oldpri -1
		}
		if { $oldpri > $pri } {
			return
		}
		set _db($cls,$resource,val) $value
		set _db($cls,$resource,pri) $pri
	} elseif { [lindex $args 0] == "get" } {
		set resource [lindex $args 2]
		set cls [lindex $args 3]
		if [info exists _db($cls,$resource,val)] {
			return $_db($cls,$resource,val)
		} else {
			return ""
		}
	} elseif { [lindex $args 0] == "clear" } {
		unset _db
	}
}
