import RTPApplication
import TemporalInterleaver

Class TInterApp -superclass RTPApplication

TInterApp instproc init args {
    $self next tinter_app

    $self init_resources;

    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec
    
    eval [$self options] parse_args $args;

    $self instvar tinter_obj_
    
    set tinter_obj_ [new TemporalInterleaver [$self get_option comm_id] [$self get_option cntrl_spec]];

    # Create UI

    scale .lfactor -from 0.0 -to 1.0 -resolution 0.01 -label Large -orient h
    .lfactor set 0.5
    .lfactor configure -command "$tinter_obj_ large_factor ";
    pack .lfactor -side top -expand 1 -fill x;

    scale .sfactor -from 0.0 -to 1.0 -resolution 0.01 -label Small -orient h
    .sfactor set 0.25
    .sfactor configure -command "$tinter_obj_ small_factor ";
    pack .sfactor -side top -expand 1 -fill x;

    scale .tol -from 1.0 -to 2.0 -resolution 0.01 -label Tolerance -orient h
    .tol set 1.25
    .tol configure -command "$tinter_obj_ expected_tolerance_factor ";
    pack .tol -side top -expand 1 -fill x;

    scale .catch -from 0.0 -to 1.0 -resolution 0.01 -label CatchUp -orient h
    .catch set 0.25
    .catch configure -command "$tinter_obj_ catch_up_factor ";
    pack .catch -side top -expand 1 -fill x;

    frame .marked
    label .marked.l -text Marked
    entry .marked.e
    pack .marked.l -side left;
    pack .marked.e -side right -expand 1 -fill x;
    pack .marked -side top -expand 1 -fill x;

    frame .unmarked
    label .unmarked.l -text Unmarked
    entry .unmarked.e
    pack .unmarked.l -side left;
    pack .unmarked.e -side right  -expand 1 -fill x;
    pack .unmarked -side top -expand 1 -fill x;

    frame .late
    label .late.l -text Late
    entry .late.e
    pack .late.l -side left;
    pack .late.e -side right -expand 1 -fill x;
    pack .late -side top -expand 1 -fill x;

    frame .expected
    label .expected.l -text "Early Expected"
    entry .expected.e
    pack .expected.l -side left;
    pack .expected.e -side right -expand 1 -fill x;
    pack .expected -side top -expand 1 -fill x;

    frame .queued
    label .queued.l -text "Early Queued"
    entry .queued.e
    pack .queued.l -side left;
    pack .queued.e -side right -expand 1 -fill x;
    pack .queued -side top -expand 1 -fill x;

    frame .late_valid
    label .late_valid.l -text "Late Valid"
    entry .late_valid.e
    pack .late_valid.l -side left;
    pack .late_valid.e -side right -expand 1 -fill x;
    pack .late_valid -side top -expand 1 -fill x;

    frame .qlength
    label .qlength.l -text "Queue Length"
    entry .qlength.e
    pack .qlength.l -side left;
    pack .qlength.e -side right -expand 1 -fill x;
    pack .qlength -side top -expand 1 -fill x;

    button .reset -text Reset -command "$tinter_obj_ reset_stats";
    pack .reset -side top -expand 1 -fill x;
    
    after 1000 $self update_ui_stats;
}

TInterApp instproc update_ui_stats {} {
    $self instvar tinter_obj_;

    .marked.e delete 0 end;
    .marked.e insert 0 [$tinter_obj_ get_marked];

    .unmarked.e delete 0 end;
    .unmarked.e insert 0 [$tinter_obj_ get_unmarked];

    .late.e delete 0 end;
    .late.e insert 0 [$tinter_obj_ get_late];

    .expected.e delete 0 end;
    .expected.e insert 0 [$tinter_obj_ get_early_expected];

    .queued.e delete 0 end;
    .queued.e insert 0 [$tinter_obj_ get_early_queued];

    .late_valid.e delete 0 end;
    .late_valid.e insert 0 [$tinter_obj_ get_late_valid];
    
    .qlength.e delete 0 end;
    .qlength.e insert 0 [$tinter_obj_ get_q_length];

    after 1000 $self update_ui_stats;
}

TInterApp instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
}

set app [new TInterApp $argv];
puts "Interleaver running on [exec hostname]";
